"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MongoClientFactory = void 0;
const inject_1 = require("@furystack/inject");
const mongodb_1 = require("mongodb");
/**
 * Factory for instantiating MongoDb clients
 */
let MongoClientFactory = class MongoClientFactory {
    constructor() {
        this.connections = new Map();
    }
    async dispose() {
        await Promise.all([...this.connections.values()].map((c) => c.close(true)));
        this.connections.clear();
    }
    async getClientFor(url, options) {
        const existing = this.connections.get(url);
        if (existing) {
            return existing;
        }
        const client = new mongodb_1.MongoClient(url, options);
        this.connections.set(url, client);
        return client;
    }
};
MongoClientFactory = __decorate([
    (0, inject_1.Injectable)({ lifetime: 'singleton' })
], MongoClientFactory);
exports.MongoClientFactory = MongoClientFactory;
//# sourceMappingURL=mongo-client-factory.js.map